#include <bits/stdc++.h>
#define FOR(i, n) for(int i = 0; i < (n); ++i)
#define REP(i, a, b) for(int i = (a); i < (b); ++i)
#define TRAV(i, a) for(auto &i : (a))
#define X first
#define Y second
#define MP std::make_pair
#define PR std::pair
#define SZ(x) ((int)(x).size())
typedef long long ll;
typedef std::pair<int, int> PII;
typedef std::vector<int> VI;

struct Node{
	Node *left;
	Node *right;
	int size;
	Node(){
		size = 0;
		left = nullptr;
		right = nullptr;
	}
};

int n, k;
Node * root;

Node * rig(Node *node){
	if(node->right == nullptr) node->right = new Node();
	return node->right;
}
Node *lef (Node *node){
	if(node->left == nullptr) node->left = new Node();
	return node->left;
}

void add(Node *node, int kto, int lev=29){
	node->size++;
	if(lev == -1) return;
	int bit = (bool)(kto & (1<<lev));
	if(bit) add(rig(node), kto, lev-1);
	else add(lef(node), kto, lev-1);
}

int ans;
void solve(Node *node, int lev=29){
	if(lev == -1) return;
	std::cout << "lev " << lev;
	std::cout << "rig " << rig(node)->size << " left " << lef(node)->size << std::endl;
	if(rig(node)->size >= k){
		ans = ans | (1<<(lev));
		solve(rig(node), lev-1);
	}else{
		solve(lef(node), lev-1);
	}
}

int main(){
	std::ios_base::sync_with_stdio(false);
	std::cin.tie(0);
	std::cin >> n >> k;
	VI A(n);
	root = new Node();
	FOR(i, n){
		std::cin >> A[i];
		std::cout << std::bitset<10>(A[i]) << std::endl;
		add(root, A[i]);
	}
	solve(root);
	std::cout << std::bitset<10>(ans) << std::endl;
	std::cout << ans;
	return 0;
}
